<template>
  <div class="testStyle" no-gutters>
    <!-- BARRA TOPO -->
    <section class="primary topBar">
      <div class="contentTopBar">
        <span class="headline text-uppercase test--text">UDESC</span>
        <v-divider class="mx-2" vertical color="white" />
        <span class="headline text-uppercase white--text font-weight-light">Polvo</span>
        <span
          class="headline white--text font-weight-light pl-2"
          style="font-size: 1.2rem !important"
          >- Avaliações
        </span>
      </div>
      <v-spacer />
      <v-btn outlined color="white" class="mr-6" @click="handleClose">Fechar</v-btn>
    </section>
    <section class="contentStyleTest">
      <!-- MENU ESQUERDA -->
      <div class="leftStyle">
        <!-- WEBCAM ALUNO -->
        <div v-if="userRole == 'student'" align="center">
          <v-btn outlined small class="mb-2" @click="webcam = !webcam">
            <v-icon small class="pr-1">mdi-camera</v-icon>
            {{ webcam ? 'Minimizar Câmera' : 'Mostrar Câmera' }}
          </v-btn>
          <Cam v-if="dialogShowTest" :style="webcam ? '' : 'display: none'" />
        </div>
        <!-- OPÇÕES ACIMA MENU-->
        <v-subheader v-if="userRole !== 'student' && !onlyView" @click="monitor">
          <a>
            <v-icon class="pr-2 pb-1" color="primary">mdi-camera-wireless</v-icon
            ><b>Monitorar Alunos</b>
          </a>
        </v-subheader>

        <!-- MENU QUESTOES PROVA -->
        <span>
          <v-subheader class="primary--text">
            <b>{{ activeTest.title }}</b>
          </v-subheader>
          <v-subheader class="primary--text">
            <v-icon small color="primary" class="pr-1">mdi-clock-outline</v-icon>
            <b class="pr-1">Tempo:</b>
            <Timer :initialDate="initialDate" :endDate="endDate" @timeEnd="timeEnd" />
          </v-subheader>
          <v-list v-if="permission.authorized" dense class="pt-0">
            <v-list-item-group color="primary" v-model="activeQuestion" mandatory>
              <v-list-item v-for="(question, index) in activeTest.questions" :key="index">
                <v-list-item-action class="mr-5">
                  <v-icon color="primary" small>mdi-circle-medium</v-icon>
                </v-list-item-action>
                <v-list-item-content @click="clickMenuTest()">
                  <v-list-item-title v-text="`Questão ${index + 1}`" />
                </v-list-item-content>
              </v-list-item>
            </v-list-item-group>
          </v-list>
          <span v-else style="font-size:0.9rem; padding-left: 1rem"
            >A prova está pronta para iniciar...</span
          >
        </span>
      </div>

      <!-- MENU DIREITA -->
      <div class="rightStyle">
        <!-- VISÃO INICIAL ALUNO -->
        <span v-if="userRole == 'student' && !permission.authorized && permission.testVision == 0">
          <v-row no-gutters justify="center" class="mb-6">
            <span class="primary--text" style="font-size:1.3rem">
              <v-icon large color="primary" class="mr-2 pb-1">mdi-alert</v-icon
              ><b>Leia com atenção</b>
            </span>
          </v-row>
          <v-row no-gutters justify="center">
            <div style=" max-width:85%">
              <b>Instruções para a avaliação:</b>
              <br /><br />
              1) Ligue sua webcam e <b>permita o acesso</b> dela para a plataforma do Polvo -
              Avaliações.
              <br />
              2) <b>Instruções:</b> {{ activeTest.instructions }}
              <br />
            </div>
          </v-row>
          <v-row no-gutters justify="center" class="mt-5">
            <v-card color="transparent" elevation="0" style="width: 80%" align="center">
              <v-btn outlined elevation="0" color="primary" @click="initTest">Iniciar Prova</v-btn>
            </v-card>
          </v-row>
        </span>

        <!-- VISÃO INICIAL MONITOR -->
        <span v-if="userRole !== 'student' && permission.testVision == 0">
          <v-row no-gutters justify="center" class="mb-6">
            <span class="primary--text" style="font-size:1.3rem">
              <v-icon large color="primary" class="mr-2 pb-1">mdi-camera-wireless</v-icon
              ><b>Monitorar Alunos</b>
            </span>
          </v-row>
          <v-row no-gutters justify="center" class="mb-6">
            <span class="primary--text" style="font-size:0.9rem">
              <b class="pr-1">Instruções do professor p/ os alunos:</b> {{ test.instructions }}
            </span>
          </v-row>
          <!-- <v-row no-gutters justify="center" class="my-5">
            <v-card color="transparent" elevation="0" style="width: 80%" align="center">
              <v-btn outlined class="mr-4" elevation="0" color="primary">Checar Solicitações</v-btn>
              <v-btn outlined elevation="0" color="primary">Autorizar Início Prova</v-btn>
            </v-card>
          </v-row> -->
          <v-row no-gutters justify="center">
            <v-row style="max-width: 90%">
              <b>Exibindo alunos:</b>
              <v-col cols="12"></v-col>
              <v-col
                cols="12"
                sm="12"
                md="6"
                lg="3"
                xl="3"
                align="center"
                v-for="(student, index) in 12"
                :key="index"
              >
                <br />
                <span>Aluno {{ index }}</span>
              </v-col>
            </v-row>
          </v-row>
        </span>

        <!-- VISÃO PROVA -->
        <span
          v-if="
            userRole == 'student' && activeTest.questions.length > 0 && permission.testVision == 1
          "
        >
          <!-- {{ activeTest.questions[activeQuestion] }} -->
          <v-row no-gutters justify="center" class="mb-4">
            <span class="primary--text" style="font-size:1.3rem">
              <v-icon large color="primary" class="mr-2 pb-1">mdi-file-document</v-icon
              ><b>{{ activeTest.title }}</b>
            </span>
          </v-row>
          <!-- LAYOUT QUESTOES -->
          <v-row no-gutters justify="center">
            <v-card style="width: 80%" class="pa-8">
              <v-row class="mb-4">
                <b>
                  Questão {{ activeQuestion + 1 }} -
                  {{ activeTest.questions[activeQuestion].body }} ({{
                    activeTest.questions[activeQuestion].weight
                  }}
                  pontos)
                </b>
              </v-row>
              <!-- VERDADEIRO OU FALSO -->
              <span v-if="activeTest.questions[activeQuestion].questionType == 'trueOrFalse'">
                <v-row
                  class="mb-1 grey--text text--darken-3"
                  v-for="(answer, index) in activeTest.questions[activeQuestion].answers"
                  :key="index"
                  no-gutters
                >
                  <v-col style="max-width: 90px; display: flex; align-self: center">
                    <span class="pr-2">{{ orderQuestion[index] }}</span>
                    <v-select
                      :disabled="finishTest"
                      v-model="answer.userAnswer"
                      class="ma-0 pa-0"
                      outlined
                      dense
                      flat
                      :items="trueFalse"
                      item-text="label"
                      item-value="value"
                    />
                  </v-col>
                  <v-col class="mt-2 ml-3" style="display:flex; align-self: start">
                    {{ answer.text }}
                  </v-col>
                </v-row>
              </span>
              <!-- DISSERTATIVA -->
              <span v-if="activeTest.questions[activeQuestion].questionType == 'dissertation'">
                <v-text-field
                  :disabled="finishTest"
                  label="Sua resposta"
                  v-model="activeTest.questions[activeQuestion].userAnswer"
                ></v-text-field>
              </span>
              <!-- OBJETIVA/MULTIPLA ESCOLHA -->
              <span v-if="activeTest.questions[activeQuestion].questionType == 'objective'">
                <v-radio-group
                  v-model="activeTest.questions[activeQuestion].userAnswer"
                  :disabled="finishTest"
                >
                  <v-radio
                    v-for="(n, index) in activeTest.questions[activeQuestion].answers"
                    :key="index"
                    :label="`${orderQuestion[index]} ${n.text}`"
                    :value="n.text"
                  >
                    <template v-slot:label>
                      <div class="grey--text text--darken-3">
                        {{ orderQuestion[index] }} {{ n.text }}
                      </div>
                    </template></v-radio
                  >
                </v-radio-group>
              </span>
              <!-- MULTIPLA ESCOLHA MULTI VALORES -->
              <span v-if="activeTest.questions[activeQuestion].questionType == 'multipleChoice'">
                <v-row
                  class="mb-1 grey--text text--darken-3"
                  v-for="(answer, index) in activeTest.questions[activeQuestion].answers"
                  :key="index"
                  no-gutters
                >
                  <v-col style="max-width: 60px; display: flex; align-self: center">
                    <span class="pr-2">{{ orderQuestion[index] }}</span>
                    <v-checkbox
                      :disabled="finishTest"
                      v-model="answer.userAnswer"
                      item-value="value"
                      class="ma-0 pa-0"
                    />
                  </v-col>
                  <v-col class="ml-0" style="display:flex; align-self: start">
                    {{ answer.text }}
                  </v-col>
                </v-row>
              </span>
              <!-- SOMATORIO -->
              <span v-if="activeTest.questions[activeQuestion].questionType == 'summation'">
                <v-row
                  class="mb-1 grey--text text--darken-3"
                  v-for="(answer, index) in activeTest.questions[activeQuestion].answers"
                  :key="index"
                  no-gutters
                >
                  <v-col style="display: flex; align-self: center">
                    <span class="pr-2">{{ Math.pow(2, index) }}.</span>
                    <v-checkbox
                      :disabled="finishTest"
                      v-model="answer.userAnswer"
                      item-value="value"
                      class="ma-0 pa-0"
                      @change="
                        summationClick(
                          Math.pow(2, index),
                          answer.userAnswer,
                          activeTest.questions[activeQuestion]
                        )
                      "
                    />
                    {{ answer.text }}
                  </v-col>
                </v-row>
                <v-row style="display: flex" class="mt-7">
                  <span class="pt-2 pr-4">
                    <b>Sua resposta:</b>
                    {{ activeTest.questions[activeQuestion].userAnswer }}
                  </span>
                </v-row>
              </span>
            </v-card>
          </v-row>
          <v-row no-gutters justify="center" class="mt-5">
            <v-card color="transparent" elevation="0" style="width: 80%" align="center">
              <v-btn
                :disabled="activeQuestion == 0"
                outlined
                class="mr-4"
                elevation="0"
                color="primary"
                @click="previousQuestion"
                >Anterior</v-btn
              >
              <v-btn
                v-if="activeQuestion !== activeTest.questions.length - 1"
                outlined
                elevation="0"
                color="primary"
                @click="nextQuestion"
                >Próxima</v-btn
              >
              <v-btn
                v-if="activeQuestion == activeTest.questions.length - 1"
                :disabled="finishTest || userRole !== 'student'"
                elevation="0"
                color="primary"
                @click="handleFinishTest"
                >Finalizar Avaliação</v-btn
              >
            </v-card>
          </v-row>
          <v-row v-if="finishTest" no-gutters justify="center" class="mt-10">
            <span>Sua avaliação <b>foi enviada</b> para correção! :)</span>
          </v-row>
        </span>
        <!-- FIM VISÃO PROVA -->
      </div>
    </section>
    <!-- Confirma conclusão prova -->
    <AlertConfirm
      :alert="alert"
      @clickCancelAlert="alert.status = false"
      @clickConfirmAlert="finish"
    />
  </div>
</template>

<script>
import Cam from '../camUser.vue'
import Timer from '../../../components/TimerCount.vue'
import Student from '../../../servicesEhq/req/student'

export default {
  name: 'ShowTest',
  props: {
    test: { type: Object, default: () => {} },
    userRole: { type: String, default: '' },
    onlyView: { type: Boolean, default: false },
    dialogShowTest: { type: Boolean, default: false },
    initialDate: { type: String, default: '' },
    endDate: { type: String, default: '' },
  },
  components: { Cam, Timer },
  data: () => ({
    activeQuestion: 0,
    activeTest: {},
    orderQuestion: [
      'a)',
      'b)',
      'c)',
      'd)',
      'e)',
      'f)',
      'g)',
      'h)',
      'i)',
      'j)',
      'k)',
      'l)',
      'm)',
      'n)',
    ],
    trueFalse: [
      { label: 'V', value: true },
      { label: 'F', value: false },
    ],
    alert: {
      status: false,
      icon: 'mdi-alert',
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    finishTest: false,
    // visão 0 - instruções para prova / visão 1 - prova
    permission: { authorized: false, testVision: 0 },
    requestAcess: true,
    webcam: true,
    userInfo: {},
  }),
  async created() {
    this.checkRoles()
    /*
    A resposta do usuário é salva dentro da propria pergunta, no objeto activeTest
    para V-F e Multipla escolha multi-respostas

    activeTest.questions[indice da pergunta].answers
    answers: {text:"alternativa", userAnswer: ""}

    na dissertativa, multipla escolha e  somatório ->  é salva em:
    activeTest.questions[indice da pergunta].userAnswer
    */
    if (this.userRole == 'student') {
      this.activeTest = JSON.parse(JSON.stringify(this.test))
      this.activeTest.questions.forEach((element) => {
        if (element.questionType !== 'dissertation') {
          // element.answers = element.correctAnswers.concat(element.incorrectAnswers)
          // element.answers.forEach((item) => {
          //   item = Object.assign(item, { userAnswer: '' })
          // })
          // element.userAnswer = ''
          this.shuffleArray(element.answers)
        } else {
          element.userAnswer = ''
        }
      })
    }

    this.userInfo = await this.$getItem('userEHQ')
  },
  watch: {
    'test.id'() {
      this.checkRoles()
      if (this.userRole == 'student' && this.test.questions.length > 0) {
        this.activeQuestion = 0
        this.activeTest = JSON.parse(JSON.stringify(this.test))
        this.activeTest.questions.forEach((element) => {
          if (element.questionType !== 'dissertation') {
            // element.answers = element.correctAnswers.concat(element.incorrectAnswers)
            // element.answers.forEach((item) => {
            //   item = Object.assign(item, { userAnswer: '' })
            // })
            // element.userAnswer = ''
            this.shuffleArray(element.answers)
          } else {
            element.userAnswer = ''
          }
        })
      }
    },
  },
  methods: {
    clickMenuTest() {
      this.permission.testVision = 1
      //salva questão
      const index = this.activeQuestion
      let answerToSend = this.saveQuestionData(this.activeTest.questions[index])

      if (answerToSend.answers.length > 0 && !this.finishTest) this.sendAnswer(answerToSend)
    },

    // método utilizado no created e no watch
    checkRoles() {
      if (this.userRole == 'admin') {
        this.permission.authorized = true
        if (this.onlyView) this.permission.testVision = 1
      }
      if (this.userRole == 'teacher') {
        this.permission.authorized = true
        if (this.onlyView) this.permission.testVision = 1
      }
      if (this.userRole == 'monitor') {
        this.permission.authorized = true
      }
    },

    handleClose() {
      this.activeQuestion = 0
      this.finishTest = false
      this.permission.authorized = false
      this.permission.testVision = 0
      this.requestAcess = false
      this.$emit('handleClose')
    },

    // métodos aluno

    initTest() {
      this.permission.authorized = true
      this.permission.testVision = 1
    },

    //métodos monitor
    monitor() {
      this.permission.testVision = 0
    },

    // métodos para PROVA
    shuffleArray(array) {
      for (let i = array.length - 1; i > 0; i--) {
        const j = Math.floor(Math.random() * (i + 1))
        ;[array[i], array[j]] = [array[j], array[i]]
      }
    },

    previousQuestion() {
      const index = this.activeQuestion
      // console.log(this.activeTest.questions[index])
      let answerToSend = this.saveQuestionData(this.activeTest.questions[index])
      if (answerToSend.answers.length > 0 && !this.finishTest) this.sendAnswer(answerToSend)

      this.activeQuestion--
    },

    nextQuestion() {
      const index = this.activeQuestion
      // console.log(this.activeTest.questions[index])
      let answerToSend = this.saveQuestionData(this.activeTest.questions[index])
      if (answerToSend.answers.length > 0 && !this.finishTest) this.sendAnswer(answerToSend)

      this.activeQuestion++
    },

    handleFinishTest() {
      const index = this.activeQuestion
      let answerToSend = this.saveQuestionData(this.activeTest.questions[index])
      if (answerToSend.answers.length > 0 && !this.finishTest) this.sendAnswer(answerToSend)

      this.alert.status = true
      this.alert.message =
        'Você tem certeza que <b>já terminou a avaliação</b><br/> e deseja <b>enviar para correção?</b><br/><br/><i style="font-size:0.9rem">Não será possível voltar e alterar as respostas caso você finalize a sua tentativa.</i>'
    },

    summationClick(value, operation, question) {
      let valor = Number(value)

      if (!question.userAnswer) question.userAnswer = Number(0)

      if (operation == true) {
        question.userAnswer = Number(question.userAnswer) + Number(valor)
      } else {
        question.userAnswer = Number(question.userAnswer) - Number(valor)
      }
    },

    saveQuestionData(obj) {
      let answer = {
        questionId: obj.id,
        studentId: this.userInfo.id,
        testId: this.test.test,
        answers: [],
      }

      if (obj.questionType == 'dissertation') {
        if (obj.userAnswer) {
          let question = { text: obj.userAnswer }
          answer.answers.push(question)
        }
      }

      if (obj.questionType == 'objective') {
        let id

        obj.answers.forEach((item) => {
          if (obj.userAnswer == item.text) id = item._id
        })

        if (id) {
          let question = { _id: id, text: obj.userAnswer }
          answer.answers.push(question)
        }
      }

      if (
        obj.questionType == 'summation' ||
        obj.questionType == 'trueOrFalse' ||
        obj.questionType == 'multipleChoice'
      ) {
        obj.answers.forEach((item) => {
          if (item.userAnswer == true) answer.answers.push(item)
        })
      }

      return answer
    },

    async finish() {
      this.alert.status = false
      this.finishTest = true
      let test = { test: this.activeTest, userId: this.userInfo.id }
      await this.$setItem('ehqTest', test)
    },

    async timeEnd() {
      console.log('tempo de prova acabou!!!')
      const index = this.activeQuestion
      let answerToSend = this.saveQuestionData(this.activeTest.questions[index])
      if (answerToSend.answers.length > 0 && !this.finishTest) this.sendAnswer(answerToSend)
      this.finish()
    },

    //backend -> enviando resposta da questão
    async sendAnswer(answer) {
      console.log(answer, 'enviei esses dados')
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Student.answerTestQuestions(answer)
        if (req.success) {
          console.log('enviou resposta')
        } else {
          console.log('não conseguiu enviar')
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
  },
}
</script>

<style>
.testStyle {
  background: white;
  height: 100vh;
  width: 100%;
  display: block;
  align-content: flex-start;
}

.topBar {
  display: flex;
  width: 100%;
  height: 64px;
  align-items: center;
  -webkit-box-shadow: 0px 3px 7px 0px rgba(50, 50, 50, 0.35);
  -moz-box-shadow: 0px 3px 7px 0px rgba(50, 50, 50, 0.35);
  box-shadow: 0px 3px 7px 0px rgba(50, 50, 50, 0.35);
}

.contentTopBar {
  display: flex;
  height: 1.6rem;
  align-items: center;
  margin-left: 68px;
}

.contentStyleTest {
  display: flex;
  min-height: calc(100% - 64px);
  /* min-height: 100%; */
  background: white;
}

.leftStyle {
  width: 256px;
  min-height: 100%;
  border-right: 1px solid rgba(50, 50, 50, 0.15);
  padding-top: 24px;
}

.rightStyle {
  width: calc(100% - 256px);
  padding-top: 24px;
}

@media all and (max-width: 800px) {
  .leftStyle {
    display: none;
    height: 100%;
  }
  .rightStyle {
    width: 100%;
    height: 100%;
    padding-top: 24px;
  }
}
</style>
